﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data.SqlClient;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.Logging;
using Nancy.Json;
using Syncfusion.EJ2.Spreadsheet;
using WebApplication.Models;

namespace WebApplication.Controllers
{
    public class HomeController : Controller
    {
     //   private readonly ILogger<HomeController> _logger;
        private readonly IConfiguration _configuration;
        private string connectionString;
        public static IServiceProvider ServiceProvider;
        public HomeController(IConfiguration configuration, IWebHostEnvironment env)
        {
            _configuration = configuration;
            connectionString = _configuration.GetConnectionString("DefaultConnection");
            connectionString = connectionString.Replace("%CONTENTROOTPATH%", env.ContentRootPath);
        }
        public IActionResult Index()
        {
            return View();
        }

        public object LoadFromTable()
        {
            List<EmployeeData> datas = new List<EmployeeData>();
            SqlConnection sqlCon = new SqlConnection(connectionString);
            SqlCommand sqlComm = new SqlCommand("SELECT * FROM [dbo].[Employees]", sqlCon);
            sqlCon.Open();
            SqlDataReader sqlDR = sqlComm.ExecuteReader();
            while (sqlDR.Read())
            {
                EmployeeData data = new EmployeeData();
                data.employeeID = (int)sqlDR.GetValue(0);
                data.lastName = sqlDR.GetValue(1).ToString();
                data.firstName = sqlDR.GetValue(2).ToString();
                data.title = sqlDR.GetValue(3).ToString();
                data.titleOfCourtesy = sqlDR.GetValue(4).ToString();
                datas.Add(data);
            }
            sqlCon.Close();
            return new { Result= datas, Count= datas.Count };
        }

        [AcceptVerbs("Post")]
        public string SaveChangesToDatabase(string JSONData)
        {
            JavaScriptSerializer serialize = new JavaScriptSerializer();
            List<EmployeeData> editedData = serialize.Deserialize<List<EmployeeData>>(JSONData);
            SqlConnection sqlCon = new SqlConnection(connectionString);
            sqlCon.Open();
            for (int i = 0; i < editedData.Count; i++)
            {
   
                var order = editedData[i];
                SqlCommand selectComm = new SqlCommand("SELECT * FROM [dbo].[Employees] WHERE [EmployeeID] = '" + order.employeeID + "'", sqlCon);
                var hasFileInDB = selectComm.ExecuteScalar();
                if (hasFileInDB == null)
                {
                    SqlCommand sqlComm = new SqlCommand("INSERT INTO [dbo].[Employees]([EmployeeID], [LastName], [FirstName], [Title], [TitleOfCourtesy]) VALUES (@EmployeeID, @LastName, @FirstName, @Title, @TitleOfCourtesy)", sqlCon);
                    sqlComm.Parameters.AddWithValue("@EmployeeID", order.employeeID);
                    sqlComm.Parameters.AddWithValue("@LastName", order.lastName);
                    sqlComm.Parameters.AddWithValue("@FirstName", order.firstName);
                    sqlComm.Parameters.AddWithValue("@Title", order.title);
                    sqlComm.Parameters.AddWithValue("@TitleOfCourtesy", order.titleOfCourtesy);
                    sqlComm.ExecuteNonQuery();
                }
                else
                {
                    SqlCommand updateComm = new SqlCommand("UPDATE [dbo].[Employees] SET LastName=@LastName, FirstName=@FirstName, Title=@Title, TitleOfCourtesy=@TitleOfCourtesy WHERE EmployeeID=@EmployeeID", sqlCon); // Update edited data to DB.
                    updateComm.CommandTimeout = 0;
                    updateComm.Parameters.AddWithValue("@EmployeeID", order.employeeID);
                    updateComm.Parameters.AddWithValue("@LastName", order.lastName);
                    updateComm.Parameters.AddWithValue("@FirstName", order.firstName);
                    updateComm.Parameters.AddWithValue("@Title", order.title);
                    updateComm.Parameters.AddWithValue("@TitleOfCourtesy", order.titleOfCourtesy);
                    updateComm.ExecuteNonQuery();
                }
            }
            sqlCon.Close();
            return "Successfully updated";
        }
        public static string GetFieldName(int index)
        {
            string[] fields = new string[] { "EmployeeID", "LastName", "FirstName", "Title", "TitleOfCourtesy" };
            return fields[index];
        }


        public IActionResult Privacy()
        {
            return View();
        }

        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }
    }

    public class OrderDetails
    {
        public string Item;
        public int Quantity;
        public int Price;
        public int Discount;
        public int Amount;
    }
    public class FileOptions
    {
        public string Name { get; set; }
    }

    public class SaveOptions
    {
        public string Name { get; set; }
        public object JSONData { get; set; }
    }

    public class EmployeeData
    {
        public int employeeID { get; set; }
        public string lastName { get; set; }
        public string firstName { get; set; }
        public string title { get; set; }
        public string titleOfCourtesy { get; set; }
    }
}
